<?php

// +---------------------------------------------------------------------------+
// | Ewiki Geeklog Plugin 1.0                                                  |
// +---------------------------------------------------------------------------+
// | admin/install.php                                                         |
// | Plugin install page                                                       |
// +---------------------------------------------------------------------------+
// | Plugin copyright (C) 2004 by the following author:                        |
// | Euan McKay                  -  euan at heatherengineering.com             |
// | Plugin project homepage:                                                  |
// | http://heatherengineering.com/                                            |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -  twillett at users dot sourceforge dot net  |
// | Blaine Lang                 -  langmail at sympatico dot ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -  tony at tonybibbs dot com                  |
// | ErfurtWiki is Public Domain                                               |
// | Written and maintained by:                                                |
// | Mario Salzer                -  mario at erphesfurt dot de                 |
// | Andy Fundinger              -  andy at burgiss dot com                    |
// | ErfurtWiki project homepage:                                              |
// | http://erfurtwiki.sourceforge.net/                                        |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// +---------------------------------------------------------------------------+

require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/ewiki/config.php');
require_once($_CONF['path'] . 'plugins/ewiki/functions.inc');

//
// Universal plugin install variables
//

$pi_name    = 'ewiki';                              // Plugin name  Must be 15 chars or less
$pi_version = '1.1';                                // Plugin Version
$gl_version = '1.3.9';                              // GL Version plugin for
$pi_url     = 'http://heatherengineering.com/';     // Plugin Homepage


// Security Features to add
// ewiki.admin = can access admin section of plugin
// ewiki.user  = can view pages in the plugin

$NEWFEATURE = array();
$NEWFEATURE['ewiki.admin'] = "ewiki Admin";
$NEWFEATURE['ewiki.user']  = "ewiki User";

$NEWTABLE = "CREATE TABLE `".$_TABLES['ewiki']."` (
    `pagename` varchar(160) NOT NULL default '',
    `version` int(10) unsigned NOT NULL default '0',
    `flags` int(10) unsigned default '0',
    `content` mediumtext,
    `author` varchar(100) default 'ewiki',
    `created` int(10) unsigned default '".time()."',
    `lastmodified` int(10) unsigned default '0',
    `refs` mediumtext,
    `meta` mediumtext,
    `hits` int(10) unsigned default '0',
    PRIMARY KEY  (`pagename`,`version`)
    ) TYPE=MyISAM;";


// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the ewiki install/uninstall page.
                  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_EW00['access_denied']);
    $display .= $LANG_EW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/*
* Puts the datastructures for this plugin into the Geeklog database
*
* Note: Corresponding uninstall routine is in functions.inc
* 
* @return   boolean True if successful False otherwise
*
*/
function plugin_install_ewiki()
{
    global $pi_name, $pi_version, $gl_version, $pi_url, $NEWFEATURE, $_TABLES, $_CONF, $NEWTABLE;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Create the plugin table
    COM_errorLog("Attempting to create $pi_name table", 1);
    DB_query($NEWTABLE,1);
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    COM_errorLog('...success',1);

    // Create the plugin admin security group
    COM_errorLog("Attempting to create $pi_name admin group", 1);
    DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) 
              VALUES ('$pi_name Admin', 'Users in this group can administer the $pi_name plugin')",1);
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $admin_id = DB_insertId();

    // Save the grp id for later uninstall
    COM_errorLog('About to save admin_id to vars table for use during uninstall',1);
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('ewiki.admin', $admin_id)",1);
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    COM_errorLog('...success',1);

    // Create the plugin user security group
    COM_errorLog("Attempting to create $pi_name user group", 1);
    DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) " . "VALUES ('$pi_name User', 'Users in this group can view the $pi_name plugin')",1);
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $user_id = DB_insertId();

    // Save the grp id for later uninstall
    COM_errorLog('About to save user_id to vars table for use during uninstall',1);
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('ewiki.user', $user_id)",1);
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    COM_errorLog('...success',1);

    // Add plugin Features
    $feature = 'ewiki.admin';
    $desc = 'Ewiki Admin';             // add admin feature
        COM_errorLog("Adding $feature feature",1);
        DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) VALUES ('$feature','$desc')",1);
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature",1);
            plugin_uninstall_gmail();
            return false;
            exit;
        }
        $feat_id = DB_insertId();      // give rights to admin group
        COM_errorLog("Success",1);
        COM_errorLog("Adding $feature feature to admin group",1);
        DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feat_id, $admin_id)");
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature to admin group",1);
            plugin_uninstall_gmail();
            return false;
            exit;
        }
    $feature = 'ewiki.user';
    $desc = 'Ewiki User';              // add user feature
        COM_errorLog("Adding $feature feature",1);
        DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) VALUES ('$feature','$desc')",1);
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature",1);
            plugin_uninstall_gmail();
            return false;
            exit;
        }
        $feat_id = DB_insertId();      // give rights to user group
        DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feat_id, $user_id)");
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature to user group",1);
            plugin_uninstall_gmail();
            return false;
            exit;
        }

    // Give Root users access to this plugin. NOTE: Root group should always be 1
    COM_errorLog("Attempting to give all users in Root group access to $pi_name admin group",1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($admin_id, NULL, 1)");
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    // Make admin users members of the user group.
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($user_id, NULL, $admin_id)");
    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }
    // Make anonymous users members of the user group (only if asked to).
    if ($_CONF['ewiki_anonymousaccess']) {
        DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($user_id, NULL, 2)");
        if (DB_error()) {
            plugin_uninstall_ewiki();
            return false;
            exit;
        }
    }

    // Register the plugin with Geeklog
    COM_errorLog("Registering $pi_name plugin with Geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name','ewiki');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        plugin_uninstall_ewiki();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);
    return true;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/ewiki/templates');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_EW00['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/ewiki/images/ewiki.gif');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/ewiki/install.php');
$T->set_var('admin_url', $_CONF['site_admin_url'] . '/plugins/ewiki/index.php');

if ($action == 'install') {
    if (plugin_install_ewiki()) {
        $T->set_var('installmsg1',$LANG_EW00['install_success']);
    } else {
        $T->set_var('installmsg1',$LANG_EW00['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_ewiki('installed');
   $T->set_var('installmsg1',$LANG_EW00['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'ewiki') == 0) {
    $T->set_var('installmsg2', $LANG_EW00['uninstalled']);
    $T->set_var('readme', $LANG_EW00['readme']);
    $T->set_var('installdoc', $LANG_EW00['installdoc']);
	$T->set_var('btnmsg', $LANG_EW00['install']);
	$T->set_var('action','install');
} else {
    $T->set_var('installmsg2', $LANG_EW00['installed']);
	$T->set_var('btnmsg', $LANG_EW00['uninstall']);
	$T->set_var('action','uninstall');
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>