<?php

require_once('../../../../lib-common.php');

// Only let admin users access this page
if (!SEC_hasRights('ewiki.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the ewiki Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_EW00['access_denied']);
    $display .= $LANG_EW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

   include("t_config.php");
?>
<html>
<head>
   <title>Revert changes</title>
</head>
<body>
   <h2>RevertChanges</h2>
<?php


if (($do = $_REQUEST["proceed"]) || ($_REQUEST["list"])) {

   if (!$do) {
      echo "<b>Warning</b>: running in <i>dummy mode</i> (--no-act), nothing will happen, all following messages are lies:\n<br><br>\n";
   }

   #-- params
   $m_author = $_REQUEST["match_author"];
   $m_time = $_REQUEST["time_slice"] * 3600;
   $action = $_REQUEST["action"];
   ($depth = $_REQUEST["version_depth"] - 1) or ($depth = 0);

   #-- walk through
   $result = ewiki_database("GETALL", array("id", "author", "lastmodified"));
   while ($row = $result->get()) {

         $id = $row["id"];

         #-- which versions to check
         $verZ = $row["version"];
         if ($action=="lastonly") {
            $verA = $verZ;
         }
         else {
            $verA = $verZ-$depth;
            if ($verA <= 0) { 
               $verA = 1;
            }
         }


         for ($ver=$verA; $ver<=$verZ; $ver++) {

            #-- load current $ver database entry
            if ($verA != $verZ) {
               $row = ewiki_database("GET", array("id"=>$id, "version"=>$ver));
            }
 
            #-- match
            if (stristr($row["author"], $m_author) && ($row["lastmodified"] + $m_time > time())) {
               echo "rm($id";
               #-- delete multiple versions
               if ($action=="allsince") {
                  while ($ver<=$verZ) {
                     echo " .$ver";
                     if ($do) {
                        ewiki_database("DELETE", array("id"=>$id, "version"=>$ver));
                     }
                     $ver++;
                  }
               }
               #-- or just the affected one
               else {
                  echo " .$ver";
                  if ($do) {
                     ewiki_database("DELETE", $row);
                  }
               }
               echo ")<br>\n";
               break;
            }

         }#-- for($ver)

   }#-- while($row)


}
else {

   ?>
     If someone garbaged lots of pages in your Wiki, you may want to
     automatically revert those changes, by making this script delete any
     page versions that carry a certain string in the {author} field
     (usually the IP address or host name).<br><br>
     <form action="<?php echo $PHP_SELF; ?>" method="GET">
       {author} field pattern <input name="match_author" size="30" value="127.127.127.127:">
       <br>
       <small>This must be a fixed string (you cannot use * or regex), at
       best use the attackers` IP address or host name, but don't include
       the port number (because it increased with every http access).
       </small>
       <br><br>
       changes within the last <input name="time_slice" size="4" value="72"> hours
       <br><br>
       how to operate:<br>
       <select name="action" size="5">
         <option selected value="lastonly">only, if it was the last change</option>
         <option value="allsince">version diving, also delete changes made after</option>
         <option value="the">version diving, but only purge the affected one</option>
       </select>
       <br>
       delete how many last versions <input name="version_depth" size="2" value="5"> at max
       <br><br>
       <input type="submit" name="list" value="--no-act">
       <input type="submit" name="proceed" value="revert changes">
     </form>
     <?php 

}



?>
</body>
</html>
