<?php

// +---------------------------------------------------------------------------+
// | Ewiki Geeklog Plugin 1.0                                                  |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | Implements Geeklog plugin API                                             |
// +---------------------------------------------------------------------------+
// | Plugin copyright (C) 2004 by the following author:                        |
// | Euan McKay                  -  euan at heatherengineering.com             |
// | Plugin project homepage:                                                  |
// | http://heatherengineering.com/                                            |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -  twillett at users dot sourceforge dot net  |
// | Blaine Lang                 -  langmail at sympatico dot ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -  tony at tonybibbs dot com                  |
// | ErfurtWiki is Public Domain                                               |
// | Written and maintained by:                                                |
// | Mario Salzer                -  mario at erphesfurt dot de                 |
// | Andy Fundinger              -  andy at burgiss dot com                    |
// | ErfurtWiki project homepage:                                              |
// | http://erfurtwiki.sourceforge.net/                                        |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// +---------------------------------------------------------------------------+

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/ewiki/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/ewiki/language/english.php');
}

/*
* Include ewiki config file
*/
require_once ($_CONF['path'] . 'plugins/ewiki/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_ewiki()
{
    global $_CONF;

    $menulabel = "Ewiki";                // Put your menu label here
    $menurul = $_CONF['site_url'] . "/ewiki/index.php";     // Menu url here

    $menuitems = array();
    if (SEC_hasRights('ewiki.user')) {
        $menuitems["$menulabel"] = $menurul;
    }
    return $menuitems;

}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_ewiki() 
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_ewiki($showsitestats) 
{
    global $_CONF, $_TABLES;

    $stat_templates = new Template($_CONF['path_layout'] . 'stats');
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));
        $retval='';
    if ($showsitestats == 1) {
        // This shows in the summary box
        $total_pages=DB_count($_TABLES['ewiki']);     // Fill this with count for summary
        $summary_label = "Ewiki";                     // Fill this with label displayed
        
        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>$summary_label</td>";
        $retval .= "<td align='right'>" . $total_pages . "&nbsp;&nbsp </td></tr></table>";
    } else {
        // This fills the top the box  Use the following as a template
        $result = DB_query("SELECT DISTINCT pagename, hits
                            FROM {$_TABLES['ewiki']}
                            WHERE hits > 0 
                            ORDER BY hits desc LIMIT 10");
        $nrows  = DB_numRows($result);
        $retval .= COM_startBlock("Top Ten Ewiki Pages");
        if ($nrows > 0) {
            $stat_templates->set_var('item_label',"Page Title");
            $stat_templates->set_var('stat_name',"Hits");
            for ($i = 0; $i < $nrows; $i++) {
                $A = DB_fetchArray($result);
                $stat_templates->set_var('item_url', $_CONF['site_url'] . '/ewiki/index.php?id=' . $A['pagename']);
                $stat_templates->set_var('item_text', $A['pagename']);
                $stat_templates->set_var('item_stat', $A['hits']);
                $stat_templates->parse('stat_row','statrow',true); 
            }
            $stat_templates->parse('output','itemstats');
            $retval .= $stat_templates->finish($stat_templates->get_var('output'));
        } else {
            $retval .= 'It appears that there are no ewikis on this site or no one has ever viewed them.';
        }    
        $retval .= COM_endBlock();
    }
    return $retval;
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_ewiki() 
{
    global $_CONF;

    return array('ewiki',$_CONF['site_admin_url'] . '/plugins/ewiki/index.php',$_CONF['site_url'] . '/ewiki/images/ewiki.gif');
}

/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify/Uncomment use it
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_ewiki() 
{
    global $_CONF, $_TABLES;

    if (SEC_hasRights('ewiki.admin') && $_CONF['ewiki_showadmin']) {
        return array('Ewiki', $_CONF['site_admin_url'] . '/plugins/ewiki/index.php', '');
    }
}

/**
* Returns the user option for this plugin
*
* Adds the plugin to the user menu
*
* Universal Plugin:  modify/uncomment use it
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
function plugin_getuseroption_ewiki() 
{
//    global $_CONF;

//    if (SEC_hasRights('ewiki.edit,ewiki.view','OR')) {
//        return array('ewiki', $_CONF['site_url'] . '/ewiki/index.php', 0);
//    }
}


/**
* Check to see if this Plugin uses the What's new block
*
* @return   boolean true or false
*
*/
function plugin_whatsnewsupported_ewiki() 
{
    global $LANG_EW02, $_CONF;
    if ($_CONF['ewiki_showwhatsnew']) {
        return (array($LANG_EW02['plugin'],
                str_replace('%duration%', $_CONF['ewiki_newpagesinterval'], $LANG_EW02['duration']))
                );
    } else {
        return false;
    }
}

/**
* Return array for the What's new block
*
* @return   array   array($headlines[], $bylines[], $content[$entries[]])
*
*/
function plugin_getwhatsnew_ewiki()
{

    global $_TABLES, $LANG_EW02, $_CONF;
    $items = array();

        $retval = "";
        $limit = time() - ($_CONF['ewiki_newpagesinterval'] * 86400);
        $sql = "SELECT pagename,created,content FROM {$_TABLES['ewiki']} 
                WHERE ({$limit} <= created) AND ( LENGTH(content) > 0 )
                ORDER BY created DESC LIMIT 10";
        $foundone = 0;
        $result = DB_query( $sql );
        $nrows = DB_numRows( $result );

        if( $nrows > 0 ) {
            $foundone = 1;
            $newlinks = array();
            for( $x = 1; $x <= $nrows; $x++ ) {
                $A = DB_fetchArray( $result );
                $A['pagename'] = stripslashes( $A['pagename'] );
                $link = $_CONF['site_url'] . '/ewiki/index.php?id=' . $A['pagename'];
                // Trim the length if over 16 characters
                $itemlen = strlen( $A['pagename'] );
                if( $itemlen > 16 ) {
                    $newlinks [] = '<a href="' . $link . '" title="'
                        . $A['title'] . '">' . substr( $A['pagename'], 0, 16 )
                        . '...</a>';
                } else {
                    $newlinks[] = '<a href="' . $link . '">' . substr( $A['pagename'], 0, $itemlen ) . '</a>';
                }
            }
        }

        if( $foundone == 0 )
        {
            $retval .= $LANG_EW02['nonewpages'] . LB;
        }
        else
        {
            $retval .= COM_makeList( $newlinks );
        }

    return ($retval);
}


/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_ewiki($installCheck='')
{
    global $_TABLES, $LANG_EW00;

    $pi_name  = 'ewiki';
    $FEATURES = array ( 'ewiki.admin', 'ewiki.user' );

    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display .= COM_startBlock($LANG_EW00['warning']);
        $display .= $LANG_EW00['enabled'];
        $display .= COM_endBlock();
        echo $display;
        return false;
        exit;
    }

    // Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the ewiki plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'ewiki'",1);

    // Drop ewiki tables
    COM_errorLog("Removing Table ewiki",1);
    DB_query("DROP TABLE ". $_TABLES['ewiki'],1);

    // Remove Security for this plugin
    $ewiki_admin = DB_getItem($_TABLES['vars'], 'value', "name = 'ewiki.admin'");
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = {$ewiki_admin}",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'ewiki.admin'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = {$ewiki_admin}",1);

    $ewiki_user = DB_getItem($_TABLES['vars'], 'value', "name = 'ewiki.user'");
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $ewiki_user",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'ewiki.user'");
    COM_errorLog("Removing root users from users of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = {$ewiki_user}",1);

    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '{$feature}'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = {$feat_id}",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = {$feat_id}",1);
    }

    COM_errorLog('...success',1);
    return true;
}


// +---------------------------------------------------------------------------+
// | Geeklog Search API Implementations                                        |
// +---------------------------------------------------------------------------+

/*
* Provide items that show up in the type drop-down on search.php.
*/
function plugin_searchtypes_ewiki() 
{
    global $LANG_EW02;

    $tmp['ewiki'] = $LANG_EW02['ewikipages'];
    return $tmp;
}


/*
* this searches for pages matching the user query and returns an array of 
* for the header and table rows back to search.php where it will be formated and
* printed 
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function plugin_dopluginsearch_ewiki($query, $datestart, $dateend, $topic, $type, $author) 
{
    global $_TABLES, $_CONF, $LANG_EW02;

    if (empty($type)) {
        $type = 'all';
    }

    // Bail if we aren't supppose to do our search
    if ($type <> 'all' AND $type <> 'ewiki') {
        $plugin_results = new Plugin();
        $plugin_results->plugin_name = 'ewiki';
        $plugin_results->searchlabel = $LANG_EW02['ewikipages'] . ": " . $LANG_EW02['results'];
        return $plugin_results;
    }

    // Build search SQL
    $sql = "SELECT * FROM {$_TABLES['ewiki']}";
    $result = DB_query($sql);

    // OK, now create new plugin object and insert table header labels
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
    $plugin_results = new Plugin();
    $plugin_results->plugin_name = 'ewiki';
    $plugin_results->searchlabel = $LANG_EW02['ewikipages'] . ": " . $LANG_EW02['results'];
    $plugin_results->addSearchHeading($LANG_EW02['title']);
    $plugin_results->addSearchHeading($LANG_EW02['created']);
    $plugin_results->addSearchHeading($LANG_EW02['hits']);
    $tot = DB_numRows($result);
    $num = 0;

    // NOTE if any of your data items need to be links then add them here! 
    // make sure data elements are in an array and in the same order as your
    // headings above!
    for ($i = 1; $i <= $tot; $i++) {
        $A = DB_fetchArray($result);
        if (strpos($A['content'],$query) || strpos($A['pagename'],$query)) {
            $row = array('<a href="'.$_CONF['site_url'].'/ewiki/index.php?id='.$A['pagename'].'">'.$A['pagename'].'</a>',
                         strftime($_CONF['date'],$A['created']),
                         $A['hits']);
            $plugin_results->addSearchResult($row);
            $num = $num+1;
        }
    }
    $plugin_results->num_searchresults = $num;
    $plugin_results->num_itemssearched = $tot;

    return $plugin_results;
}

?>