<?php

// +---------------------------------------------------------------------------+
// | Ewiki Geeklog Plugin 1.0                                                  |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// | Plugin main user page                                                     |
// +---------------------------------------------------------------------------+
// | Plugin copyright (C) 2004 by the following author:                        |
// | Euan McKay                  -  euan at heatherengineering.com             |
// | Plugin project homepage:                                                  |
// | http://heatherengineering.com/                                            |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -  twillett at users dot sourceforge dot net  |
// | Blaine Lang                 -  langmail at sympatico dot ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -  tony at tonybibbs dot com                  |
// | ErfurtWiki is Public Domain                                               |
// | Written and maintained by:                                                |
// | Mario Salzer                -  mario at erphesfurt dot de                 |
// | Andy Fundinger              -  andy at burgiss dot com                    |
// | ErfurtWiki project homepage:                                              |
// | http://erfurtwiki.sourceforge.net/                                        |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// +---------------------------------------------------------------------------+

require_once('../lib-common.php');

// Check user has rights to access this page
if (!SEC_hasRights('ewiki.user,ewiki.admin','OR')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the ewiki page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_EW00['access_denied']);
    $display .= $LANG_EW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/*
* Main Function
*/

include($_CONF['path_html'] . '/ewiki/ewiki/config.php');

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/ewiki/templates');
$T->set_file('page', 'index.thtml');
$T->set_var('header', $LANG_EW00['plugin']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('plugin','ewiki');
$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= ewiki_page();
$display .= COM_siteFooter();

echo $display;

?>
